#!/usr/bin/python

# RSS Mix Tape
# Copyright 2003, David "Novalis" Turner <novalis@fsf.org>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


from qt import *

from FeedDB2 import feedDB
from Feed2 import Feed
from NewFeed import NewFeed
import Interval

class NewFeedImpl (NewFeed):
    def __init__ (self, parent):
        NewFeed.__init__ (self, parent, "New Feed", 1)
        secs = Interval.revtimes.keys ()
        secs.sort ()
        self.interval.insertStrList ([Interval.revtimes [x] for x in secs])
        self.interval.setCurrentItem (7)

    def accept (self):
        url = str (self.url.text ())
        title = str (self.title.text ())
        interval = Interval.times [str (self.interval.currentText ())]

        if url and title:
            feedDB ().addFeed (Feed (title, interval, url))
            NewFeed.accept (self)
