#!/usr/bin/python
#!/usr/bin/python

# RSS Mix Tape
# Copyright 2003, David "Novalis" Turner <novalis@fsf.org>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.        
from LockFile import LockFile

import os
import ConfigParser

dir = os.path.expanduser ("~/.rssmixtape/")

if not os.path.exists (dir):
    os.mkdir (dir)

def counter ():
    lock = LockFile (dir + "id.lock")
    lock.lock ()
    try:
        f = open (dir + "id")
        x = int (f.read ()) + 1
        f.close ()
        f = open (dir + "id", "w")
        f.write (str (x))
        f.close ()
    except:
        f = open (dir + "id", "w")
        f.write ("0")
        f.close ()
        x = 0
    lock.unlock ()
    return x


class config:
    _inst = None
    def __init__ (self):
        self.config = ConfigParser.ConfigParser ()
        self.config.read (dir + 'config')
        if not self.config.has_section ("main"):
            self.config.add_section ("main")
        self.categories = None
        
    def get (self, opt):
        if not self.config.has_option ("main", opt):
            return None
        return self.config.get ("main", opt)

    def set (self, opt, val):
        return self.config.set ("main", opt, str (val))

    def write (self):
        fp = open (dir + 'config', "w")
        self.config.write (fp)

    def getCategories (self):
        if not self.categories:
            catstr = config._inst.get ("categories")
            if not catstr:
                return []
            cats = catstr.split (",")
            self.categories = map (str.strip, cats)
        return self.categories
    
    def setCategories (self, cats):
        self.categories = cats
        config._inst.set ("categories", ",".join (cats))

if not config._inst:
    config._inst = config ()

def get (opt):
    return config._inst.get (opt)

def set (opt, value):
    return config._inst.set (opt, value)

def save ():
    config._inst.write ()

def getCategories ():
    return config._inst.getCategories ()

def setCategories (cats):
    return config._inst.setCategories (cats)
